----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:11:48 11/22/2014 
-- Design Name: 
-- Module Name:    Map_Decoder - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Map_Decoder is
    Port ( Clk : in  STD_LOGIC;
			  slow_clk : in STD_LOGIC; 
			  enable : in STD_LOGIC;
			  reset : in STD_LOGIC; 
           display_address : out  STD_LOGIC_VECTOR (7 downto 0);
           Row : out  STD_LOGIC_VECTOR (7 downto 0);
           First_Row_Enable : out  STD_LOGIC;
           map_progress_address : out  STD_LOGIC_VECTOR (7 downto 0);
			  end_of_map : out STD_LOGIC );
end Map_Decoder;



architecture Behavioral of Map_Decoder is

component map_progress_counter is
	Port (enable, clk, reset : in std_logic;
			count : out std_logic_vector (7 downto 0));
end component; 

component display_counter is 
	Port (enable, clk : in std_logic; 
			count : out std_logic_vector (2 downto 0));
end component;

component ripple_carry_adder is
	Port (A, B : in std_logic_vector (7 downto 0); 
			Cout : out std_logic; 
			Sum : out std_logic_vector (7 downto 0));
end component; 

component standard_decoder_3to8 is 
	Port (dec_in : in std_logic_vector (2 downto 0); 
			dec_out : out std_logic_vector (7 downto 0));
end component; 

signal temp : std_logic_vector (2 downto 0) := "000"; 
signal display_count : std_logic_vector (7 downto 0) := "00000000";
signal map_progress_count : std_logic_vector (7 downto 0) := "00000000"; 
begin
	
	display_counter0: display_counter port map ( enable => '1', 
															  clk => clk, 
															  count => temp);
	display_count(0) <= temp(0); 
	display_count(1) <= temp(1); 
	display_count(2) <= temp(2); 
	display_count(3) <= '0';
	display_count(4) <= '0';
	display_count(5) <= '0';
	display_count(6) <= '0';
	display_count(7) <= '0';
	
	
	map_progress_counter0: map_progress_counter port map (enable => enable,
												  reset => reset, 
												  clk => slow_clk, 
												  count => map_progress_count); 
	map_progress_address <= map_progress_count;
												  
	address_adder : ripple_carry_adder port map ( 	A => display_count, 
																	B => map_progress_count, 
																	Cout => end_of_map, 
																	Sum => display_address); 
	
first_row_check : process(temp,clk)
begin
	if (temp = "000") then 
		 first_row_enable <= '1';
	else 
		first_row_enable <= '0'; 
	end if;
end process first_row_check; 
															  
standard_decoder : standard_decoder_3to8 port map (dec_in => temp, 
																			  dec_out => row); 


end Behavioral;

