----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:24:32 11/12/2014 
-- Design Name: 
-- Module Name:    Move_FSM - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL; 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Move_FSM is
    Port ( Clk : in STD_LOGIC;
--			  start : in STD_LOGIC;
			  Left : in  STD_LOGIC;
           Right : in  STD_LOGIC;
           Position : out  STD_LOGIC_VECTOR (7 downto 0));	  
end Move_FSM;

architecture Behavioral of Move_FSM is

type state_type is (maintain, move_left, move_right, stop_left1, stop_left2, stop_right1, stop_right2, stop_all);

component clk_div
	Port (clk : in std_logic; 
			sclk : out std_logic); 
end component; 

signal current_state,next_state: state_type;  --current and next state declaration..
signal pos_value, pos_value_next : std_logic_vector (2 downto 0) := "100"; --start in the middle
signal slow_clk : std_logic; 

begin

	my_clk: clk_div 
	port map (clk => clk,
	          sclk => slow_clk ); 
				 
start_new: process (slow_clk)
begin
-- if (start='1') then
--  current_state <= maintain;   --default state on reset.
--  pos_value <= "100";
--  --pos_value_next <= "100";
if (rising_edge(slow_clk)) then
  current_state <= next_state;   --state change.
  pos_value <= pos_value_next;	--reassign position
end if;
end process start_new;


state: process(current_state, left, right, pos_value)
begin 
pos_value_next <= pos_value;
case current_state is
when maintain =>        
   if(left ='0' and right = '1') then
      		next_state <= move_right;
   elsif(left = '1' and right = '0') then 
	  	next_state <= move_left;
	elsif(left = '1' and right = '1') then 
	  	next_state <= stop_all;
	else 
		next_state <= maintain;
	end if;   
when move_right =>        
     	if(left = '1' and right = '1') then
		next_state <= stop_all;
	else
		if (pos_value < "111")then
			pos_value_next <= pos_value + 1;
		end if;
		next_state <= stop_right1;
	end if;	
when move_left =>  
	if(left = '1' and right = '1') then 
		next_state <= stop_all;
	else
		if (pos_value > "000")then
			pos_value_next <= pos_value - 1;
		end if;
		
		next_state <= stop_left1;
	end if;
when stop_right1 =>
	if((left = '1' and right = '1') or (left = '1' and right = '0')) then 
		next_state <= move_left; 
     	elsif(left = '0' and right = '0') then
		next_state <= maintain;
	else 
		next_state <= stop_right1;
	end if;	
when stop_left1 =>
	if((left = '1' and right = '1') or (left = '0' and right = '1')) then 
		next_state <= move_right;
	elsif(left = '0' and right = '0') then 
		next_state <= maintain;
	else
		next_state <= stop_left1; 
	end if;
when stop_all =>
	if(left = '0' and right = '0') then 
		next_state <= maintain; 
	elsif(left = '0' and right = '1') then 
		next_state <= stop_right2; 
	elsif(left = '1' and right = '0') then 
		next_state <= stop_left2; 
	else
		next_state <= stop_all;
	end if;
when stop_right2 =>
	if((left = '1' and right = '1') or (left = '1' and right = '0')) then 
		next_state <= move_left;
	elsif(left = '0' and right = '1') then 
		next_state <= stop_right2; 
	else
		next_state <= maintain; 
	end if;
when stop_left2 =>
	if((left = '1' and right = '1') or (left = '0' and right = '1')) then 
		next_state <= move_right;
	elsif(left = '1' and right = '0') then 
		next_state <= stop_left2; 
	else
		next_state <= maintain; 
	end if;
end case;
end process state;


decode: process(Clk, pos_value)
begin
case pos_value is 
	when "000" => position <= "10000000"; 
	when "001" => position <= "01000000";
	when "010" => position <= "00100000";
	when "011" => position <= "00010000";
	when "100" => position <= "00001000";
	when "101" => position <= "00000100";
	when "110" => position <= "00000010";
	when others => position <= "00000001";
end case;
end process decode;


end Behavioral;

