----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:50:37 10/08/2014 
-- Design Name: 
-- Module Name:    RippleCarryAdder4Bit - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.std_logic_unsigned.all; 

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Ripple_Carry_Adder is
    Port ( A : in  STD_LOGIC_VECTOR (7 downto 0);
           B : in  STD_LOGIC_VECTOR (7 downto 0);
           Cout : out  STD_LOGIC;
           sum : out  STD_LOGIC_VECTOR (7 downto 0));
end Ripple_Carry_Adder;

architecture Behavioral of Ripple_Carry_Adder is
component FullAdder is 
	Port (A, B, carry_in : in std_logic; 
			sum, carry_out : out std_logic); 
end component; 
component HalfAdder is 
	Port (A, B : in std_logic;
			sum, carry_out : out std_logic); 
end component; 
signal t1, t2, t3, t4, t5, t6, t7: std_logic; 
begin
	 
	h0 : HalfAdder port map ( A => A(0), 
									  B => B(0), 
									  carry_out => t1, 
									  sum => sum(0));
	f1 : FullAdder port map ( A => A(1),
									  B => B(1),
									  carry_in => t1, 
									  carry_out => t2, 
									  sum => sum(1));							  
	f2 : FullAdder port map ( A => A(2),
									  B => B(2),
									  carry_in => t2, 
									  carry_out => t3, 
									  sum => sum(2));		
	f3 : FullAdder port map ( A => A(3),
									  B => B(3),
									  carry_in => t3, 
									  carry_out => t4, 
									  sum => sum(3));
	f4 : FullAdder port map ( A => A(4),
									  B => B(4),
									  carry_in => t4, 
									  carry_out => t5, 
									  sum => sum(4));
	f5 : FullAdder port map ( A => A(5),
									  B => B(5),
									  carry_in => t5, 
									  carry_out => t6, 
									  sum => sum(5));
	f6 : FullAdder port map ( A => A(6),
									  B => B(6),
									  carry_in => t6, 
									  carry_out => t7, 
									  sum => sum(6));
	f7 : FullAdder port map ( A => A(7),
									  B => B(7),
									  carry_in => t7, 
									  carry_out => Cout, 
									  sum => sum(7));

									  
end Behavioral;

