----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    10:57:36 11/24/2014 
-- Design Name: 
-- Module Name:    game - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity game is
    Port ( left : in  STD_LOGIC;
           right : in  STD_LOGIC;
           clk : in  STD_LOGIC;
           display_row : inout  STD_LOGIC_VECTOR (7 downto 0);
           display_column_red : out  STD_LOGIC_VECTOR (7 downto 0);
			  display_column_blue : out  STD_LOGIC_VECTOR (7 downto 0);
			  display_column_green : out  STD_LOGIC_VECTOR (7 downto 0);
           score_number_display : out  STD_LOGIC_VECTOR (7 downto 0);
           start : in  STD_LOGIC;
           score_digit_display : out  STD_LOGIC_VECTOR (3 downto 0);
			  end_of_map : out STD_LOGIC);
end game;

architecture Behavioral of game is

component map_decoder is 
    Port ( Clk : in  STD_LOGIC;
			  slow_clk : in STD_LOGIC; 
           display_address : out  STD_LOGIC_VECTOR (7 downto 0);
           Row : out  STD_LOGIC_VECTOR (7 downto 0);
			  enable : in STD_LOGIC; 
			  reset : in STD_LOGIC;
           First_Row_Enable : out  STD_LOGIC;
           map_progress_address : out  STD_LOGIC_VECTOR (7 downto 0);
			  end_of_map : out STD_LOGIC );
end component; 

component move_fsm is 
    Port ( Clk : in STD_LOGIC;
--			  start : in STD_LOGIC;
			  Left : in  STD_LOGIC;
           Right : in  STD_LOGIC;
           Position : out  STD_LOGIC_VECTOR (7 downto 0));	  
end component; 
 
component buffer_with_output_enable is 
    Port ( data_in : in  STD_LOGIC_VECTOR (7 downto 0);
           Clk : in  STD_LOGIC;
           output_enable : in  STD_LOGIC;
			  data_out : out std_logic_vector (7 downto 0));
end component; 

component sseg_dec is 
    Port (      ALU_VAL : in std_logic_vector(7 downto 0); 
					    SIGN : in std_logic;
						VALID : in std_logic;
                    CLK : in std_logic;
                DISP_EN : out std_logic_vector(3 downto 0); 
               SEGMENTS : out std_logic_vector(7 downto 0));
end component;

component scroll_clk is
    Port (  clk : in std_logic;
           scroll_clk_out : out std_logic);
end component;

component win_lose_logic is
    Port ( obstacles : in  STD_LOGIC_VECTOR (7 downto 0);
           position : in  STD_LOGIC_VECTOR (7 downto 0);
			  first_row_enable :std_logic;
           score : in  STD_LOGIC_VECTOR (7 downto 0);
			  win_lose : out STD_LOGIC_VECTOR (1 downto 0));
end component;

COMPONENT map_rom is
PORT (
     clka : IN STD_LOGIC;
    addra : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
    douta : OUT STD_LOGIC_VECTOR(7 DOWNTO 0));
END COMPONENT; 

--type state_type is (won, lost, playing);	

signal display_address : std_logic_vector(7 downto 0); 
signal first_row_enable : std_logic; 
signal score : std_logic_vector (7 downto 0); 
signal position : std_logic_vector (7 downto 0); 
signal win_lose : std_logic_vector (1 downto 0); 
signal scroll_clk_out : std_logic; 
--signal end_game_enable : std_logic; 
signal output_enable1 : std_logic; 
signal obstacles : std_logic_vector (7 downto 0);
signal obstacles_out : std_logic_vector (7 downto 0);
signal reset : std_logic;  

--signal current_state, next_state : state_type; 

begin

scroll_clk0 : scroll_clk port map (clk => clk, 
											  scroll_clk_out => scroll_clk_out); 

map_decoder0 : map_decoder port map (Clk => Clk, 
												 slow_clk => scroll_clk_out, 
												 display_address => display_address, 
												 row => display_row,
												 enable => '1', --end_game_enable, --enable 
												 reset => reset, 
												 first_row_enable => first_row_enable, 
												 map_progress_address => score, 
												 end_of_map => end_of_map);

map_rom0 : map_rom port map (clka => clk, 
									  addra => display_address, 
									  douta => obstacles);

buffer_with_output_enable0 : buffer_with_output_enable port map ( data_in => obstacles, 
																						Clk => clk, 
																						output_enable => '1', --end_game_enable, 
																						data_out => obstacles_out); 
									  
									  
win_lose_logic0 : win_lose_logic port map (obstacles => obstacles, 
														 position => position, 
														 first_row_enable => first_row_enable,
														 score => score, 
														 win_lose => win_lose); 
														 

sseg_dec0 : sseg_dec port map (ALU_VAL => score,  
										 SIGN => '0', 
										 VALID => '1', 
										 CLK => clk, 
										 DISP_EN => score_digit_display, 
										 SEGMENTS => score_number_display);
										 
move_fsm0 : move_fsm port map ( Clk => Clk, 
	--									  start => start, 
										  Left => left, 
										  Right => right, 
										  Position => position);	 

output_enable1 <= '1' when ((reset = '0') and (first_row_enable = '0'))else '0'; --(display_row= "01111111"))

buffer_with_output_enable1 : buffer_with_output_enable port map (data_in => position,
																						clk => clk, 
																						output_enable => output_enable1,
																						data_out => display_column_green);  

 
start_new: process (win_lose, obstacles_out)
begin

--reset <= '1'; 

if (win_lose = "11") then 
	display_column_blue <= "00000000"; 
	display_column_red <= "11111111"; 
	reset <= '1'; 
elsif (win_lose = "00") then 
	display_column_red <= "00000000";
	display_column_blue <= "11111111"; 
	reset <= '1'; 
else
	reset <= '0';
	display_column_blue <= "11111111";
	display_column_red <= obstacles_out; 
end if;
end process start_new;																										  

end Behavioral;

